diff -ruN vdr-1.7.12/skinsttng.c vdr-1.7.13/skinsttng.c
--- vdr-1.7.12/skinsttng.c	2010-01-03 15:51:35.000000000 +0100
+++ vdr-1.7.13/skinsttng.c	2010-02-13 14:30:59.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: skinsttng.c 2.4 2010/01/03 14:51:35 kls Exp $
+ * $Id: skinsttng.c 2.5 2010/02/13 13:30:59 kls Exp $
  */
 
 // Star Trek: The Next Generation® is a registered trademark of Paramount Pictures
@@ -49,9 +49,12 @@
 #include "symbols/teletext.xpm"
 #include "symbols/volume.xpm"
 
-#define Roundness   10
-#define Gap          5
-#define ScrollWidth  5
+#define Roundness     (Setup.FontOsdSize / 2)
+#define Gap           (Setup.FontOsdSize / 5)
+#define ScrollWidth   (Setup.FontOsdSize / 4)
+#define TextFrame     (Setup.FontOsdSize / 10)
+#define TextSpacing   (Setup.FontOsdSize / 4)
+#define SymbolSpacing (Setup.FontOsdSize / 4)
 
 static cTheme Theme;
 
@@ -161,7 +164,7 @@
   message = false;
   if (withInfo) {
      x0 = 0;
-     x1 = x0 + font->Width("00:00") + 4;
+     x1 = x0 + font->Width("00:00") + 2 * TextFrame;
      x2 = x1 + Roundness;
      x3 = x2 + Gap;
      x7 = cOsd::OsdWidth();
@@ -240,28 +243,27 @@
 void cSkinSTTNGDisplayChannel::SetChannel(const cChannel *Channel, int Number)
 {
   osd->DrawRectangle(x3, y0, x4 - 1, y1 - 1, frameColor);
-  int x = x4 - 5;
+  int x = x4 - SymbolSpacing;
   if (Channel && !Channel->GroupSep()) {
-     int d = 3;
      bool rec = cRecordControls::Active();
-     x -= bmRecording.Width() + d;
+     x -= bmRecording.Width() + SymbolSpacing;
      osd->DrawBitmap(x, y0 + (y1 - y0 - bmRecording.Height()) / 2, bmRecording, Theme.Color(rec ? clrChannelSymbolRecFg : clrChannelSymbolOff), rec ? Theme.Color(clrChannelSymbolRecBg) : frameColor);
-     x -= bmEncrypted.Width() + d;
+     x -= bmEncrypted.Width() + SymbolSpacing;
      osd->DrawBitmap(x, y0 + (y1 - y0 - bmEncrypted.Height()) / 2, bmEncrypted, Theme.Color(Channel->Ca() ? clrChannelSymbolOn : clrChannelSymbolOff), frameColor);
-     x -= bmDolbyDigital.Width() + d;
+     x -= bmDolbyDigital.Width() + SymbolSpacing;
      osd->DrawBitmap(x, y0 + (y1 - y0 - bmDolbyDigital.Height()) / 2, bmDolbyDigital, Theme.Color(Channel->Dpid(0) ? clrChannelSymbolOn : clrChannelSymbolOff), frameColor);
-     x -= bmAudio.Width() + d;
+     x -= bmAudio.Width() + SymbolSpacing;
      osd->DrawBitmap(x, y0 + (y1 - y0 - bmAudio.Height()) / 2, bmAudio, Theme.Color(Channel->Apid(1) ? clrChannelSymbolOn : clrChannelSymbolOff), frameColor);
      if (Channel->Vpid()) {
-        x -= bmTeletext.Width() + d;
+        x -= bmTeletext.Width() + SymbolSpacing;
         osd->DrawBitmap(x, y0 + (y1 - y0 - bmTeletext.Height()) / 2, bmTeletext, Theme.Color(Channel->Tpid() ? clrChannelSymbolOn : clrChannelSymbolOff), frameColor);
         }
      else if (Channel->Apid(0)) {
-        x -= bmRadio.Width() + d;
+        x -= bmRadio.Width() + SymbolSpacing;
         osd->DrawBitmap(x, y0 + (y1 - y0 - bmRadio.Height()) / 2, bmRadio, Theme.Color(clrChannelSymbolOn), frameColor);
         }
      }
-  osd->DrawText(x3 + 2, y0, ChannelString(Channel, Number), Theme.Color(clrChannelName), frameColor, cFont::GetFont(fontOsd), x - x3 - 2);
+  osd->DrawText(x3 + TextFrame, y0, ChannelString(Channel, Number), Theme.Color(clrChannelName), frameColor, cFont::GetFont(fontOsd), x - x3 - TextFrame);
 }
 
 void cSkinSTTNGDisplayChannel::SetEvents(const cEvent *Present, const cEvent *Following)
@@ -276,9 +278,9 @@
   for (int i = 0; i < 2; i++) {
       const cEvent *e = !i ? Present : Following;
       if (e) {
-         osd->DrawText(x0 + 2, y3 + 2 * i * lineHeight, e->GetTimeString(), Theme.Color(clrChannelEpgTime), frameColor, cFont::GetFont(fontOsd));
-         osd->DrawText(x3 + 2, y3 + 2 * i * lineHeight, e->Title(), Theme.Color(clrChannelEpgTitle), Theme.Color(clrBackground), cFont::GetFont(fontOsd), x4 - x3 - 2);
-         osd->DrawText(x3 + 2, y3 + (2 * i + 1) * lineHeight, e->ShortText(), Theme.Color(clrChannelEpgShortText), Theme.Color(clrBackground), cFont::GetFont(fontSml), x4 - x3 - 2);
+         osd->DrawText(x0 + TextFrame, y3 + 2 * i * lineHeight, e->GetTimeString(), Theme.Color(clrChannelEpgTime), frameColor, cFont::GetFont(fontOsd));
+         osd->DrawText(x3 + TextFrame, y3 + 2 * i * lineHeight, e->Title(), Theme.Color(clrChannelEpgTitle), Theme.Color(clrBackground), cFont::GetFont(fontOsd), x4 - x3 - TextFrame);
+         osd->DrawText(x3 + TextFrame, y3 + (2 * i + 1) * lineHeight, e->ShortText(), Theme.Color(clrChannelEpgShortText), Theme.Color(clrBackground), cFont::GetFont(fontSml), x4 - x3 - TextFrame);
          }
       }
 }
@@ -309,13 +311,13 @@
         cString date = DayDateTime();
         int w = font->Width(date);
         if (!*lastDate || strcmp(date, lastDate)) {
-           osd->DrawText(x4 - w - 2, y7 - font->Height(), date, Theme.Color(clrChannelDate), frameColor, font, w);
+           osd->DrawText(x4 - w - TextFrame, y7 - font->Height(), date, Theme.Color(clrChannelDate), frameColor, font, w);
            lastDate = date;
            }
         cDevice *Device = cDevice::PrimaryDevice();
         const tTrackId *Track = Device->GetTrack(Device->GetCurrentAudioTrack());
         if (!Track && *lastTrackId.description || Track && strcmp(lastTrackId.description, Track->description)) {
-           osd->DrawText(x3 + 2, y6, Track ? Track->description : "", Theme.Color(clrChannelName), frameColor, font, x4 - x3 - w - 4);
+           osd->DrawText(x3 + TextFrame, y6, Track ? Track->description : "", Theme.Color(clrChannelName), frameColor, font, x4 - x3 - w - 2 * TextFrame);
            strn0cpy(lastTrackId.description, Track ? Track->description : "", sizeof(lastTrackId.description));
            }
         }
@@ -493,7 +495,7 @@
   const cFont *font = cFont::GetFont(fontOsd);
   const char *VDR = " VDR";
   int w = font->Width(VDR);
-  osd->DrawText(x3 + 5, y0, Title, Theme.Color(clrMenuTitle), frameColor, font, x4 - w - x3 - 5);
+  osd->DrawText(x3 + TextSpacing, y0, Title, Theme.Color(clrMenuTitle), frameColor, font, x4 - w - x3 - TextSpacing);
   osd->DrawText(x4 - w, y0, VDR, frameColor, clrBlack, font, w, lineHeight);
 }
 
@@ -501,9 +503,9 @@
 {
   cString date = DayDateTime();
   const cFont *font = cFont::GetFont(fontSml);
-  int d = 10;
+  int d = 2 * Gap;
   int d2 = d / 2;
-  int t4 = x4 - font->Width(date) - 2;
+  int t4 = x4 - font->Width(date) - TextFrame;
   int w = t4 - x3;
   int t0 = x3 + d2;
   int t1 = x3 + w / 4;
@@ -558,13 +560,13 @@
   for (int i = 0; i < MaxTabs; i++) {
       const char *s = GetTabbedText(Text, i);
       if (s) {
-         int xt = x3 + 5 + Tab(i);
+         int xt = x3 + TextSpacing + Tab(i);
          osd->DrawText(xt, y, s, ColorFg, ColorBg, font, x4 - xt);
          }
       if (!Tab(i + 1))
          break;
       }
-  SetEditableWidth(x4 - x3 - 5 - Tab(1));
+  SetEditableWidth(x4 - x3 - TextSpacing - Tab(1));
 }
 
 void cSkinSTTNGDisplayMenu::SetScrollbar(int Total, int Offset)
@@ -577,7 +579,7 @@
   if (!Event)
      return;
   const cFont *font = cFont::GetFont(fontOsd);
-  int xl = x3 + 5;
+  int xl = x3 + TextSpacing;
   int y = y3;
   cTextScroller ts;
   char t[32];
@@ -637,7 +639,7 @@
      return;
   const cRecordingInfo *Info = Recording->Info();
   const cFont *font = cFont::GetFont(fontOsd);
-  int xl = x3 + 5;
+  int xl = x3 + TextSpacing;
   int y = y3;
   cTextScroller ts;
   char t[32];
@@ -710,7 +712,7 @@
      if (!*lastDate || strcmp(date, lastDate)) {
         const cFont *font = cFont::GetFont(fontSml);
         int w = font->Width(date);
-        osd->DrawText(x4 - w - 2, y7 - font->Height(), date, Theme.Color(clrMenuDate), frameColor, font, w);
+        osd->DrawText(x4 - w - TextFrame, y7 - font->Height(), date, Theme.Color(clrMenuDate), frameColor, font, w);
         lastDate = date;
         }
      }
@@ -806,7 +808,7 @@
 
 void cSkinSTTNGDisplayReplay::SetTitle(const char *Title)
 {
-  osd->DrawText(x3 + 5, y0, Title, Theme.Color(clrReplayTitle), frameColor, cFont::GetFont(fontSml), x4 - x3 - 5);
+  osd->DrawText(x3 + TextSpacing, y0, Title, Theme.Color(clrReplayTitle), frameColor, cFont::GetFont(fontSml), x4 - x3 - TextSpacing);
 }
 
 static const char *const *ReplaySymbols[2][2][5] = {
@@ -844,7 +846,7 @@
 {
   const cFont *font = cFont::GetFont(fontSml);
   int w = font->Width(Total);
-  osd->DrawText(x4 - w - 5, y6, Total, Theme.Color(clrReplayTotal), frameColor, font, w);
+  osd->DrawText(x4 - w - TextSpacing, y6, Total, Theme.Color(clrReplayTotal), frameColor, font, w);
 }
 
 void cSkinSTTNGDisplayReplay::SetJump(const char *Jump)
@@ -924,10 +926,10 @@
 
 void cSkinSTTNGDisplayVolume::SetVolume(int Current, int Total, bool Mute)
 {
-  int xl = x3 + 5;
-  int xr = x4 - 5;
-  int yt = y0 + 3;
-  int yb = y1 - 3;
+  int xl = x3 + TextSpacing;
+  int xr = x4 - TextSpacing;
+  int yt = y0 + TextFrame;
+  int yb = y1 - TextFrame;
   if (mute != Mute) {
      osd->DrawRectangle(x3, y0, x4 - 1, y1 - 1, frameColor);
      mute = Mute;
@@ -935,9 +937,9 @@
   cBitmap bm(Mute ? mute_xpm : volume_xpm);
   osd->DrawBitmap(xl, y0 + (y1 - y0 - bm.Height()) / 2, bm, Theme.Color(clrVolumeSymbol), frameColor);
   if (!Mute) {
-     xl += bm.Width() + 5;
+     xl += bm.Width() + TextSpacing;
      int w = (y1 - y0) / 3;
-     int d = 3;
+     int d = TextFrame;
      int n = (xr - xl + d) / (w + d);
      int x = xr - n * (w + d);
      tColor Color = Theme.Color(clrVolumeBarLower);
@@ -988,7 +990,7 @@
   int ItemsWidth = font->Width(Title);
   for (int i = 0; i < NumTracks; i++)
       ItemsWidth = max(ItemsWidth, font->Width(Tracks[i]));
-  ItemsWidth += 10;
+  ItemsWidth += 2 * TextSpacing;
   x0 = 0;
   x1 = lineHeight / 2;
   x3 = (x1 + Roundness + Gap + 7) & ~0x07; // must be multiple of 8
@@ -1052,7 +1054,7 @@
   osd->DrawRectangle(x3, y6, x4 - 1, y7 - 1, frameColor);
   osd->DrawRectangle(x5, y6, x6 - 1, y7 - 1, frameColor);
   osd->DrawEllipse  (x6, y6, x7 - 1, y7 - 1, frameColor, 5);
-  osd->DrawText(x3 + 5, y0, Title, Theme.Color(clrMenuTitle), frameColor, font, x4 - x3 - 5);
+  osd->DrawText(x3 + TextSpacing, y0, Title, Theme.Color(clrMenuTitle), frameColor, font, x4 - x3 - TextSpacing);
   for (int i = 0; i < NumTracks; i++)
       SetItem(Tracks[i], i, false);
 }
@@ -1084,7 +1086,7 @@
         }
      }
   const cFont *font = cFont::GetFont(fontOsd);
-  int xt = x3 + 5;
+  int xt = x3 + TextSpacing;
   osd->DrawText(xt, y, Text, ColorFg, ColorBg, font, x4 - xt);
 }
 
@@ -1105,7 +1107,7 @@
     default: ;
     }
   if (bm)
-     osd->DrawBitmap(x3 + 5, y6 + (y7 - y6 - bm->Height()) / 2, *bm, Theme.Color(clrChannelSymbolOn), frameColor);
+     osd->DrawBitmap(x3 + TextSpacing, y6 + (y7 - y6 - bm->Height()) / 2, *bm, Theme.Color(clrChannelSymbolOn), frameColor);
   else
      osd->DrawRectangle(x3, y6, x4 - 1, y7 - 1, frameColor);
 }
diff -ruN vdr-1.7.12/sourceparams.c vdr-1.7.13/sourceparams.c
--- vdr-1.7.12/sourceparams.c	1970-01-01 01:00:00.000000000 +0100
+++ vdr-1.7.13/sourceparams.c	2010-02-28 13:15:49.000000000 +0100
@@ -0,0 +1,43 @@
+/*
+ * sourceparams.c: Source parameter handling
+ *
+ * See the main source file 'vdr.c' for copyright information and
+ * how to reach the author.
+ *
+ * $Id: sourceparams.c 1.1 2010/02/28 12:15:49 kls Exp $
+ */
+
+#include "sourceparams.h"
+#include "sources.h"
+
+// --- cSourceParam ----------------------------------------------------------
+
+cSourceParam::cSourceParam(char Source, const char *Description)
+{
+  source = Source;
+  if ('A' <= source && source <= 'Z') {
+     if (SourceParams.Get(source)) {
+        esyslog("ERROR: source parameters for '%c' already defined", source);
+        return;
+        }
+     SourceParams.Add(this);
+     if (Source != 'C' && Source != 'S' && Source != 'T')
+        Sources.Add(new cSource(Source, Description));
+     dsyslog("registered source parameters for '%c - %s'", source, Description);
+     }
+  else
+     esyslog("ERROR: invalid source '%c'", source);
+}
+
+// --- cSourceParams ---------------------------------------------------------
+
+cSourceParams SourceParams;
+
+cSourceParam *cSourceParams::Get(char Source) const
+{
+  for (cSourceParam *sp = First(); sp; sp = Next(sp)) {
+      if (sp->Source() == Source)
+         return sp;
+      }
+  return NULL;
+}
diff -ruN vdr-1.7.12/sourceparams.h vdr-1.7.13/sourceparams.h
--- vdr-1.7.12/sourceparams.h	1970-01-01 01:00:00.000000000 +0100
+++ vdr-1.7.13/sourceparams.h	2010-02-28 12:58:03.000000000 +0100
@@ -0,0 +1,53 @@
+/*
+ * sourceparams.h: Source parameter handling
+ *
+ * See the main source file 'vdr.c' for copyright information and
+ * how to reach the author.
+ *
+ * $Id: sourceparams.h 1.1 2010/02/28 11:58:03 kls Exp $
+ */
+
+#ifndef __SOURCEPARAMS_H
+#define __SOURCEPARAMS_H
+
+#include "channels.h"
+#include "osdbase.h"
+#include "tools.h"
+
+class cSourceParam : public cListObject {
+private:
+  char source;
+public:
+  cSourceParam(char Source, const char *Description);
+    ///< Sets up a parameter handler for the given Source.
+    ///< Source must be in the range 'A'...'Z', and there can only
+    ///< be one cSourceParam for any given source.
+    ///< Description contains a short, one line description of this source.
+    ///< If a plugin sets up a new cSourceParam, this will also trigger
+    ///< defining the appropriate cSource automatically.
+    ///< Objects of cSourceParam shall only be created on the heap, and
+    ///< shall never be deleted (they will be deleted automatically when
+    ///< the program ends).
+  char Source(void) const { return source; }
+  virtual void SetData(cChannel *Channel) = 0;
+    ///< Sets all source specific parameters to those of the given Channel.
+    ///< Must also reset a counter to use with later calls to GetOsdItem().
+  virtual void GetData(cChannel *Channel) = 0;
+    ///< Copies all source specific parameters to the given Channel.
+  virtual cOsdItem *GetOsdItem(void) = 0;
+    ///< Returns all the OSD items necessary for editing the source
+    ///< specific parameters of the channel that was given in the last
+    ///< call to SetData(). Each call to GetOsdItem() returns exactly
+    ///< one such item. After all items have been fetched, any further
+    ///< calls to GetOsdItem() return NULL. After another call to
+    ///< SetData(), the OSD items can be fetched again.
+  };
+
+class cSourceParams : public cList<cSourceParam> {
+public:
+  cSourceParam *Get(char Source) const;
+  };
+
+extern cSourceParams SourceParams;
+
+#endif //__SOURCEPARAMS_H
diff -ruN vdr-1.7.12/sources.c vdr-1.7.13/sources.c
--- vdr-1.7.12/sources.c	2008-02-10 15:07:26.000000000 +0100
+++ vdr-1.7.13/sources.c	2010-02-28 13:00:31.000000000 +0100
@@ -4,11 +4,10 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: sources.c 2.0 2008/02/10 14:07:26 kls Exp $
+ * $Id: sources.c 2.1 2010/02/28 12:00:31 kls Exp $
  */
 
 #include "sources.h"
-#include <ctype.h>
 
 // --- cSource ---------------------------------------------------------------
 
@@ -18,6 +17,12 @@
   description = NULL;
 }
 
+cSource::cSource(char Source, const char *Description)
+{
+  code = int(Source) << 24;
+  description = strdup(Description);
+}
+
 cSource::~cSource()
 {
   free(description);
@@ -36,58 +41,50 @@
 {
   char buffer[16];
   char *q = buffer;
-  switch (Code & st_Mask) {
-    case stCable: *q++ = 'C'; break;
-    case stSat:   *q++ = 'S';
-                  {
-                    int pos = Code & ~st_Mask;
-                    q += snprintf(q, sizeof(buffer) - 2, "%u.%u", (pos & ~st_Neg) / 10, (pos & ~st_Neg) % 10); // can't simply use "%g" here since the silly 'locale' messes up the decimal point
-                    *q++ = (Code & st_Neg) ? 'E' : 'W';
-                  }
-                  break;
-    case stTerr:  *q++ = 'T'; break;
-    default:      *q++ = Code + '0'; // backward compatibility
-    }
+  *q++ = (Code & st_Mask) >> 24;
+  int n = (Code & st_Pos);
+  if (n > 0x00007FFF)
+     n |= 0xFFFF0000;
+  if (n) {
+     q += snprintf(q, sizeof(buffer) - 2, "%u.%u", abs(n) / 10, abs(n) % 10); // can't simply use "%g" here since the silly 'locale' messes up the decimal point
+     *q++ = (n < 0) ? 'E' : 'W';
+     }
   *q = 0;
   return buffer;
 }
 
 int cSource::FromString(const char *s)
 {
-  int type = stNone;
-  switch (toupper(*s)) {
-    case 'C': type = stCable; break;
-    case 'S': type = stSat;   break;
-    case 'T': type = stTerr;  break;
-    case '0' ... '9': type = *s - '0'; break; // backward compatibility
-    default: esyslog("ERROR: unknown source key '%c'", *s);
-             return stNone;
-    }
-  int code = type;
-  if (type == stSat) {
-     int pos = 0;
-     bool dot = false;
-     bool neg = false;
-     while (*++s) {
-           switch (toupper(*s)) {
-             case '0' ... '9': pos *= 10;
-                               pos += *s - '0';
-                               break;
-             case '.':         dot = true;
-                               break;
-             case 'E':         neg = true; // fall through to 'W'
-             case 'W':         if (!dot)
-                                  pos *= 10;
-                               break;
-             default: esyslog("ERROR: unknown source character '%c'", *s);
-                      return stNone;
-             }
-           }
-     if (neg)
-        pos |= st_Neg;
-     code |= pos;
+  if ('A' <= *s && *s <= 'Z') {
+     int code = int(*s) << 24;
+     if (code == stSat) {
+        int pos = 0;
+        bool dot = false;
+        bool neg = false;
+        while (*++s) {
+              switch (*s) {
+                case '0' ... '9': pos *= 10;
+                                  pos += *s - '0';
+                                  break;
+                case '.':         dot = true;
+                                  break;
+                case 'E':         neg = true; // fall through to 'W'
+                case 'W':         if (!dot)
+                                     pos *= 10;
+                                  break;
+                default: esyslog("ERROR: unknown source character '%c'", *s);
+                         return stNone;
+                }
+              }
+        if (neg)
+           pos = -pos;
+        code |= (pos & st_Pos);
+        }
+     return code;
      }
-  return code;
+  else
+    esyslog("ERROR: unknown source key '%c'", *s);
+  return stNone;
 }
 
 int cSource::FromData(eSourceType SourceType, int Position, bool East)
@@ -95,7 +92,7 @@
   int code = SourceType;
   if (SourceType == stSat) {
      if (East)
-        code |= st_Neg;
+        Position = -Position;
      code |= (Position & st_Pos);;
      }
   return code;
diff -ruN vdr-1.7.12/sources.conf vdr-1.7.13/sources.conf
--- vdr-1.7.12/sources.conf	2009-12-23 15:35:49.000000000 +0100
+++ vdr-1.7.13/sources.conf	2010-02-28 13:05:32.000000000 +0100
@@ -21,7 +21,7 @@
 
 S3E     Telecom 2C
 S4E     Eurobird 4
-S5E     Sirius 4
+S4.8E   Sirius 4
 S7E     Eutelsat W3A
 S9E     Eurobird 9
 S10E    Eutelsat W1
@@ -190,8 +190,8 @@
 
 # Cable
 
-C       Cable
+C       DVB-C
 
 # Terrestrial
 
-T       Terrestrial
+T       DVB-T
diff -ruN vdr-1.7.12/sources.h vdr-1.7.13/sources.h
--- vdr-1.7.12/sources.h	2005-05-14 11:30:41.000000000 +0200
+++ vdr-1.7.13/sources.h	2010-02-21 17:11:19.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: sources.h 2.0 2005/05/14 09:30:41 kls Exp $
+ * $Id: sources.h 2.1 2010/02/21 16:11:19 kls Exp $
  */
 
 #ifndef __SOURCES_H
@@ -15,19 +15,19 @@
 class cSource : public cListObject {
 public:
   enum eSourceType {
-    stNone  = 0x0000,
-    stCable = 0x4000,
-    stSat   = 0x8000,
-    stTerr  = 0xC000,
-    st_Mask = 0xC000,
-    st_Neg  = 0x0800,
-    st_Pos  = 0x07FF,
+    stNone  = 0x00000000,
+    stCable = ('C' << 24),
+    stSat   = ('S' << 24),
+    stTerr  = ('T' << 24),
+    st_Mask = 0xFF000000,
+    st_Pos  = 0x0000FFFF,
     };
 private:
   int code;
   char *description;
 public:
   cSource(void);
+  cSource(char Source, const char *Description);
   ~cSource();
   int Code(void) const { return code; }
   const char *Description(void) const { return description; }
diff -ruN vdr-1.7.12/tools.c vdr-1.7.13/tools.c
--- vdr-1.7.12/tools.c	2009-12-23 16:12:15.000000000 +0100
+++ vdr-1.7.13/tools.c	2010-02-28 14:31:46.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: tools.c 2.6 2009/12/23 15:12:15 kls Exp $
+ * $Id: tools.c 2.7 2010/02/28 13:31:46 kls Exp $
  */
 
 #include "tools.h"
@@ -1423,6 +1423,8 @@
         LOG_ERROR_STR(tempName);
         result = false;
         }
+     fflush(f);
+     fsync(fileno(f));
      if (fclose(f) < 0) {
         LOG_ERROR_STR(tempName);
         result = false;
diff -ruN vdr-1.7.12/vdr.c vdr-1.7.13/vdr.c
--- vdr-1.7.12/vdr.c	2010-01-31 12:14:40.000000000 +0100
+++ vdr-1.7.13/vdr.c	2010-02-21 15:08:09.000000000 +0100
@@ -22,7 +22,7 @@
  *
  * The project's page is at http://www.tvdr.de
  *
- * $Id: vdr.c 2.16 2010/01/31 11:14:40 kls Exp $
+ * $Id: vdr.c 2.17 2010/02/21 14:08:09 kls Exp $
  */
 
 #include <getopt.h>
@@ -58,6 +58,7 @@
 #include "shutdown.h"
 #include "skinclassic.h"
 #include "skinsttng.h"
+#include "sourceparams.h"
 #include "sources.h"
 #include "themes.h"
 #include "timers.h"
@@ -1303,6 +1304,7 @@
   Remotes.Clear();
   Audios.Clear();
   Skins.Clear();
+  SourceParams.Clear();
   if (ShutdownHandler.GetExitCode() != 2) {
      Setup.CurrentChannel = cDevice::CurrentChannel();
      Setup.CurrentVolume  = cDevice::CurrentVolume();
